<template>
  <div id="orders">
    <div v-if="orders">
      <div class="order-filter">
        <input type="text" placeholder="Поиск ..." class="main-input" v-model="filterKey">
      </div>
      <card-loader class="container" :loopCount="1" :type="'orders'" v-if="!orders"/>
      <div v-if="orders.length >= 1" class="single-order container" v-for="order in limitedOrders">
        <div class="order-header">
          <div class="row">
            <div class="col-lg-6 col-sm-12 col-sm-12">
              <p v-if="loggedInUser.isAdmin">Пользователь: {{order.user.fullName}}</p> 
              <p>Дата заказа: {{order.date}}</p> 
              <p>Сумма заказа: {{order.totalPrice}} грн <span v-if="order.promoCode">(ПРОМОКОД: {{order.promoCode.discount}} %)</span></p>
            </div>
          </div>
        </div>
        <div class="order-body">
          <div class="order-product" v-for="pr in order.cartProducts">
            <div>
              <div class="img-wrapper">
                <img :src="pr.files.find(f => f.main).url">
              </div>
              <div class="order-product-descr">
                <p><b>{{pr.productName}}</b></p>
                <p>Размер: {{pr.itemType}}</p>
                <p>Цена: {{getPrice(order, pr)}} грн</p>
              </div>
            </div>
          </div>
        </div>
        <div class="order-footer">
          <div class="col-sm-6" v-if="loggedInUser.isAdmin">
            <div class="form-group m-dropdown" v-click-outside="hideStatus(order._id)">
              <label for="status">Статус</label>
              
              <input class="main-input" @focus="showStatus = order._id;" autocomplete="off" name="status" v-model="order.status">

              <ul v-if="showStatus === order._id" class="m-dropdown-menu" >
                <li v-for="c in statuses" @click.stop="setStatus(order, c)">{{c}}</li>
              </ul>
            </div>
          </div>
          <p class="order-status" v-else>Статус: {{order.status}}</p>

          <div class="col-sm-6">
            <button v-if="order.status !== 'Canceled'" class="action-button black-button pull-right" @click="cancelOrder(order)">Отменить Заказ</button>
            <button v-if="loggedInUser.isAdmin" class="details-button action-button gray-button pull-right" @click="viewOrderDetails(order)">Информация</button>
            <div class="clearfix"></div>
          </div>
        </div>

      </div>
      <nav class="navigation pagination" v-if="noPages.length > 1">
        <div class="nav-links">
          <a :class="{disabled: (currentPage === 0)}" @click="previous" class="prev page-numbers">Предыдущая</a>
          <a v-for="(page, ind) in noPages" class="page-numbers" :class="{current: page === currentPage}" @click='(e) => {goToPage(page, e)}'><span class="meta-nav screen-reader-text"></span>{{page + 1}}</a>
          <a :class="{disabled: (currentPage + 1 === noPages.length)}" class="next page-numbers" @click="next">Следующая</a>
        </div>
      </nav>
      <div v-if="orders.length < 1" class="empty-orders">
        <div>
          <div><span class="order-box"></span></div>
          <h6>У Вас нет оформленных заказов. Совершите покупки сейчас.</h6>
          <button class="action-button gray-button" @click="$router.push('/products')">В МАГАЗИН</button>
        </div>
      </div>
    </div>
    <div v-else>
      <div class="single-order container">
        <div class="order-header">
          <div class="row">
            <div class="col-lg-6 col-sm-12 col-sm-12">
              <p class="order-loading-string"></p>
            </div>
          </div>
        </div>
        <div class="order-body">
          <div class="order-product" >
            <div class="row">
              <div class="col-lg-2 col-md-3 col-sm-12" >
                <p class="order-loading-string"></p>
              </div>
              <div class="col-lg-6 col-md-5 col-sm-12 order-product-descr">
                <p class="order-loading-string"></p>
              </div>
              <div class="col-lg-4 col-md-4 col-sm-12 order-product-status">
              </div>
            </div>
          </div>
        </div>
        <div class="order-footer">
          <div class="col-sm-6">
            <p class="order-loading-string"></p>
          </div>
        </div>
      </div>
    </div>

    <modal :header="'Подтверждение Действия'" :isShow="showModal" v-if="showModal" @close="showModal = false">
      <div slot="body">
        <p>Вы уверены что хотите изменить статус заказа ?</p>
      </div>

      <div slot="footer">
        <button class="action-button black-button" @click="confirmStatusChange">ДА</button>
        <button class="action-button gray-button" @click="showModal = false;">Отменить</button>
      </div>
    </modal>

    <modal :header="'Отмена Заказа'" :isShow="showCancelOrder" v-if="showCancelOrder" @close="showCancelOrder = false">
      <div slot="body">
        <p>Вы уверены, что хотите отменить заказ ?</p>
      </div>

      <div slot="footer">
        <button class="action-button black-button" @click="confirmCancelOrder">ДА</button>
        <button class="action-button gray-button" @click="showCancelOrder = false;">Отмена</button>
      </div>
    </modal>

    <modal :header="'Информация о заказе'" :isShow="orderDetailsModal" :width="'700'" v-if="orderDetailsModal" @close="orderDetailsModal = false">
      <div slot="body">
        <p><b>Ф.И.О.: </b> <span> {{activeOrder.userDetails.fullName}}</span></p>
        <p><b>Способ Отправки:</b> <span> {{activeOrder.userDetails.shippingType}}</span></p>
        <p v-if="activeOrder.userDetails.office"><b>Номер Отделения:</b> <span> {{activeOrder.userDetails.office}}</span></p>
        <p><b>Город:</b> <span> {{activeOrder.userDetails.city}}</span></p>
        <p><b>Телефон:</b> <span> +380 {{activeOrder.userDetails.phone}}</span></p>
        <p v-if="activeOrder.userDetails.zip"><b>Город:</b> <span> {{activeOrder.userDetails.city}}</span></p>
        <p v-if="activeOrder.userDetails.comment"><b>Комментарий:</b> <span> {{activeOrder.userDetails.comment}}</span></p>
      </div>

      <div slot="footer">
        <button class="action-button gray-button ok-button" @click="orderDetailsModal = false;">OK</button>
      </div>
    </modal>
  </div>
</template>
<script>
import CardLoader from "@/components/shared/CardLoader";
import Modal from "@/components/shared/Modal";
import {
  getLoggedInUser
} from "@/components/shared/service/authService";
export default {
  data() {
    return {
      showStatus: false, showModal: false, orderDetailsModal: false, showCancelOrder: false,
      orders: undefined, activeOrder: undefined,
      filterKey: '',
      currentPage: 0,
      statuses: ['Обрабатывается', 'Отправлено', 'Получено']
    }
  },
  methods: {
    loadOrders,
    hideStatus,
    setStatus, 
    confirmStatusChange,
    viewOrderDetails,
    cancelOrder,
    confirmCancelOrder,
    getPrice,
    previous: function (e) { // Previous page click handler
      e.preventDefault()
      if (this.currentPage !== 0) {
        --this.currentPage
      }
    },
    next: function (e) { // Next page click handler
      e.preventDefault()
      if (this.currentPage + 1 !== this.noPages.length) {
        ++this.currentPage
      }
    },
    goToPage: function (page, e) { // Go to a specific page click handler
      e.preventDefault();
      this.currentPage = page;
    },
    firstPage: function(e) {
      e.preventDefault();
      this.currentPage = 0;
    }
  },
  watch: {
    showStatus: function(nVal) {
      console.log(nVal);
    }
  },
  mounted() {
    this.loggedInUser = getLoggedInUser();
    this.loadOrders();
  },
  computed: {
    noPages: function () { // No. pages as an array. Used for rendering paginator
      if (!this.filteredData) return [];
      let pages = Math.ceil(this.filteredData.length / 5);
      pages = [...Array(pages).keys()];
      pages = pages.filter(num => {
        return num < this.currentPage + 5 && num > this.currentPage - 5;
      }); 

      return pages;
    },
    limitedOrders: function() {
      if (!this.filteredData) return [];
      let limitedData = this.filteredData.slice(
        this.currentPage * 5,
        5 * (this.currentPage + 1)
      );
      return limitedData;
    },
    filteredData: function () { // Data filtered through the local search
      if (!this.orders) return [];
      let filterKey = this.filterKey && this.filterKey.toLowerCase();
      let data = this.orders;
      if (filterKey) {
        data = data.filter((pr) => pr.user.fullName.toLowerCase().indexOf(filterKey) > -1 || pr._id.indexOf(filterKey) > -1);
      }
      
      return data
    }
  },
  components: {
    CardLoader, Modal
  }
}

function getPrice(order, pr) {
  if (pr.discount) {
    return parseFloat(pr.itemPrice) - (pr.itemPrice * (pr.discount / 100));
  } else if (order.promoCode && order.promoCode.categories.includes(pr.productCategory)) {
    return parseFloat(pr.itemPrice) - (pr.itemPrice * (order.promoCode.discount / 100));
  } else {
    return pr.itemPrice;
  }
}

function cancelOrder(order) {
  this.activeOrder = order;
  this.showCancelOrder = true;
}

function confirmCancelOrder(e) {
  e.target.disabled = true;
  this.$http.put(`${process.env.VUE_APP_BASE_URL}/orders/${this.activeOrder._id}/cancel`).then(() => {
    e.target.disabled = false;
    this.showCancelOrder = false;
    this.activeOrder.status = 'Canceled';
  }).catch(err => {
    console.log(err);
  });
}

function viewOrderDetails(order) {
  this.activeOrder = order;
  this.orderDetailsModal = true;
}

function confirmStatusChange(e) {
  e.target.disabled = true;
  this.$http.put(`${process.env.VUE_APP_BASE_URL}/orders/${this.activeOrder._id}/change-status`, this.activeOrder).then(() => {
    e.target.disabled = false;
    this.showModal = false;
  }).catch(err => {
    console.log(err);
  })
}

function setStatus(order, status) {
  order.status = status;
  this.activeOrder = order;
  this.showStatus = false;
  this.showModal = true;
}

function hideStatus(orderId) {
  let self = this;
  return function() {
    if (self.showStatus === orderId) {
      self.showStatus = false;
    }
  }
}

function loadOrders() {
  this.$http.get(`${process.env.VUE_APP_BASE_URL}/orders`).then(resp => {
    resp.data = resp.data.sort((a, b) =>  new Date(b.date) - new Date(a.date));
    resp.data.forEach(order => {
      order.date = this.$moment(order.date).format('DD MM YYYY');
    });
    this.orders = resp.data;
  }).catch(err => {
    console.log(err);
  })
}


</script>
<style lang="scss">
  #orders {
    min-height: 500px;
    padding: 20px 0;
    .order-filter {
      max-width: 300px;
      margin-bottom: 20px;
    }
    .single-order {
      margin-bottom: 20px;
      background-color: #f9f9f9;
    }
    .order-status {
      padding: 0 15px;
    }
    .order-header {
      padding: 15px;
      border-bottom: 1px solid lightgray;
      font-size: 18px;

      .row {
        width: 100%;
        .order-id-wrapper {
          padding: 10px;
          display: inline-block;
        }

        p {
          margin-bottom: 0;
          color: #A9A9A9;
          font-size: 16px;
        }
        .order-id {
          color: gray;
        }
      }
    }
    @media (min-width: 576px) {
      .order-header {
        display: flex;
        justify-content: space-between;
      }
    }

    .order-body {
      padding: 15px;
      border-bottom: 1px solid lightgray;
      .order-product {
        margin-bottom: 10px;
        display: inline-block;
        margin-right: 10px;
        max-width: 180px;
        vertical-align: top;
        .img-wrapper {
          height: 220px;
          display: block;
          img {
            max-height: 100%;
          }
        }
        .order-product-status p {
          text-align: right;
        }
        .order-product-descr, .order-product-status {
          font-size: 14px;
          p {
            margin-bottom: 5px;
          }
        }
      }
    }
    @media (max-width: 768px) {
      .order-body {
        padding: 7px;
        .order-product {
          margin-right: 1%;
          margin-left: 1%;
          width: 48%;
          img {
            width: 100%;
          }
        }
      }
    }
    .order-footer {
      padding-bottom: 15px;
      p {
        margin: 20px 0 0;
        line-height: 46px;
      }
      button {
        max-width: 300px;
      }

      .details-button {
        margin-right: 10px;
        max-width: 150px;
      }
    }

    @media (min-width: 576px) {
      .order-footer {
        display: flex;
        justify-content: space-between;
      }
    }

    .empty-orders {
      & > div {
        margin: 0 auto;
        max-width: 400px;
      }
      .order-box {
        height: 80px;
        width: 80px;
        display: block;
        background-image: url('../../assets/box.svg');
        background-position: center;
        background-size: cover;
        margin: 0 auto 20px;
      }
    }

    .order-loading-string {
      min-width: 100px;
      min-height: 15px;
      background-color: lightgray;
    }
  }
</style>